package com.yeejoin.amos.boot.module.jcs.biz.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.yeejoin.amos.boot.biz.common.controller.BaseController;
import com.yeejoin.amos.boot.biz.common.utils.NameUtils;
import com.yeejoin.amos.boot.module.jcs.api.entity.AlertSubmittedObject;
import com.yeejoin.amos.boot.module.jcs.biz.service.impl.AlertSubmittedObjectServiceImpl;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.ReflectionUtils;
import org.springframework.web.bind.annotation.*;
import org.typroject.tyboot.core.foundation.enumeration.UserType;
import org.typroject.tyboot.core.restful.doc.TycloudOperation;
import org.typroject.tyboot.core.restful.exception.instance.BadRequest;

import javax.servlet.http.HttpServletRequest;
import java.util.Arrays;


/**
* 报送对象
*
* @author tb
* @date 2021-06-17
*/
@RestController
@Api(tags = "报送对象Api")
@RequestMapping(value = "/alert-submitted-object")
public class AlertSubmittedObjectController extends BaseController {

    @Autowired
    AlertSubmittedObjectServiceImpl iAlertSubmittedObjectService;

    /**
    * 新增报送对象
    * @return
    */
    @TycloudOperation(ApiLevel = UserType.AGENCY)
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ApiOperation(httpMethod = "POST", value = "新增报送对象", notes = "新增报送对象")
    public boolean saveAlertSubmittedObject(HttpServletRequest request, @RequestBody AlertSubmittedObject alertSubmittedObject){
        return iAlertSubmittedObjectService.save(alertSubmittedObject);
    }

    /**
    * 根据id删除
    * @param id
    * @return
    */
    @TycloudOperation(ApiLevel = UserType.AGENCY)
    @RequestMapping(value = "/{id}", method = RequestMethod.DELETE)
    @ApiOperation(httpMethod = "DELETE", value = "根据id删除", notes = "根据id删除")
    public boolean deleteById(HttpServletRequest request, @PathVariable Long id){
        return iAlertSubmittedObjectService.removeById(id);
    }

    /**
    * 修改报送对象
    * @return
    */
    @TycloudOperation(ApiLevel = UserType.AGENCY)
    @RequestMapping(value = "/updateById", method = RequestMethod.PUT)
    @ApiOperation(httpMethod = "PUT", value = "修改报送对象", notes = "修改报送对象")
    public boolean updateByIdAlertSubmittedObject(HttpServletRequest request, @RequestBody AlertSubmittedObject alertSubmittedObject){
        return iAlertSubmittedObjectService.updateById(alertSubmittedObject);
    }

    /**
    * 根据id查询
    * @param id
    * @return
    */
    @TycloudOperation(ApiLevel = UserType.AGENCY)
    @RequestMapping(value = "/{id}", method = RequestMethod.GET)
    @ApiOperation(httpMethod = "GET", value = "根据id查询", notes = "根据id查询")
    public AlertSubmittedObject selectById(HttpServletRequest request, @PathVariable Long id){
        return iAlertSubmittedObjectService.getById(id);
    }

    /**
    * 列表分页查询
    * @return
    */
    @TycloudOperation(ApiLevel = UserType.AGENCY)
    @RequestMapping(value = "/list", method = RequestMethod.GET)
    @ApiOperation(httpMethod = "GET", value = "列表分页查询", notes = "列表分页查询")
    public IPage<AlertSubmittedObject> listPage(String pageNum,String pageSize, AlertSubmittedObject alertSubmittedObject){

        Page<AlertSubmittedObject> pageBean;
        QueryWrapper<AlertSubmittedObject> alertSubmittedObjectQueryWrapper = new QueryWrapper<>();
        Class<? extends AlertSubmittedObject> aClass = alertSubmittedObject.getClass();
        Arrays.stream(aClass.getDeclaredFields()).forEach(field -> {
            try {
                ReflectionUtils.makeAccessible(field);
                Object o = field.get(alertSubmittedObject);
                if (o != null) {
                    Class<?> type = field.getType();
                    String name = NameUtils.camel2Underline(field.getName());
                    if (type.equals(Integer.class)) {
                        Integer fileValue = (Integer) field.get(alertSubmittedObject);
                        alertSubmittedObjectQueryWrapper.eq(name, fileValue);
                    } else if (type.equals(Long.class)) {
                        Long fileValue = (Long) field.get(alertSubmittedObject);
                        alertSubmittedObjectQueryWrapper.eq(name, fileValue);
                    } else {
                        String fileValue = (String) field.get(alertSubmittedObject);
                        alertSubmittedObjectQueryWrapper.eq(name, fileValue);
                    }
                }
            } catch (Exception e) {
                throw  new BadRequest("系统异常");
            }
        });
        IPage<AlertSubmittedObject> page;
        if (StringUtils.isBlank(pageNum) || StringUtils.isBlank(pageSize)) {
            pageBean = new Page<>(0, Long.MAX_VALUE);
        } else {
            pageBean = new Page<>(Integer.parseInt(pageNum), Integer.parseInt(pageSize));
        }
        page = iAlertSubmittedObjectService.page(pageBean, alertSubmittedObjectQueryWrapper);
            return page;
        }
    }

